"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var promisify = require("util.promisify");
var path = require("path");
var commit_1 = require("./commit");
var statAsync = promisify(fs.stat);
var readFileAsync = promisify(fs.readFile);
var readDirAsync = promisify(fs.readdir);
var Repository = (function () {
    function Repository(gitDir) {
        this.gitDir = gitDir;
    }
    Repository.findGitDir = function (repositoryPath) {
        if (repositoryPath === void 0) { repositoryPath = process.cwd(); }
        return __awaiter(this, void 0, void 0, function () {
            var gitDir, stat, gitDirRef, err_1, parent_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 7]);
                        gitDir = path.resolve(repositoryPath, '.git');
                        return [4 /*yield*/, statAsync(gitDir)];
                    case 1:
                        stat = _a.sent();
                        if (!stat.isDirectory()) return [3 /*break*/, 2];
                        return [2 /*return*/, gitDir];
                    case 2:
                        if (!stat.isFile()) return [3 /*break*/, 4];
                        return [4 /*yield*/, readFileAsync(gitDir, 'utf8').trim().split(/\s/).pop()];
                    case 3:
                        gitDirRef = _a.sent();
                        return [2 /*return*/, path.resolve(repositoryPath, gitDirRef)];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        err_1 = _a.sent();
                        parent_1 = path.resolve(repositoryPath, '..');
                        if (repositoryPath === parent_1)
                            return [2 /*return*/];
                        return [4 /*yield*/, Repository.findGitDir(parent_1)];
                    case 6: return [2 /*return*/, _a.sent()];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    Repository.findGitDirSync = function (repositoryPath) {
        if (repositoryPath === void 0) { repositoryPath = process.cwd(); }
        try {
            var gitDir = path.resolve(repositoryPath, '.git');
            var stat = fs.statSync(gitDir);
            if (stat.isDirectory()) {
                return gitDir;
            }
            else if (stat.isFile()) {
                var gitDirRef = fs.readFileSync(gitDir, 'utf8').trim().split(/\s/).pop();
                return path.resolve(repositoryPath, gitDirRef);
            }
        }
        catch (err) {
            var parent_2 = path.resolve(repositoryPath, '..');
            if (repositoryPath === parent_2)
                return;
            return Repository.findGitDirSync(parent_2);
        }
    };
    Repository.prototype.readHead = function () {
        return __awaiter(this, void 0, void 0, function () {
            var s, name_1, _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, readFileAsync(path.join(this.gitDir, 'HEAD'), 'utf8')];
                    case 1:
                        s = (_d.sent()).trim();
                        if (!s.startsWith('ref')) return [3 /*break*/, 3];
                        name_1 = s.split(path.sep).pop();
                        _a = {
                            type: 'branch'
                        };
                        _b = {
                            name: name_1
                        };
                        return [4 /*yield*/, this.readCommitByBranch(name_1)];
                    case 2: return [2 /*return*/, (_a.branch = (_b.commit = _d.sent(),
                            _b),
                            _a)];
                    case 3:
                        _c = {
                            type: 'commit'
                        };
                        return [4 /*yield*/, commit_1.Commit.readCommit(this.gitDir, s)];
                    case 4: return [2 /*return*/, (_c.commit = _d.sent(),
                            _c)];
                }
            });
        });
    };
    Repository.prototype.readHeadSync = function () {
        var s = fs.readFileSync(path.join(this.gitDir, 'HEAD'), 'utf8').trim();
        if (s.startsWith('ref')) {
            var name_2 = s.split(path.sep).pop();
            return {
                type: 'branch',
                branch: {
                    name: name_2,
                    commit: this.readCommitByBranchSync(name_2),
                }
            };
        }
        else {
            return {
                type: 'commit',
                commit: commit_1.Commit.readCommitSync(this.gitDir, s),
            };
        }
    };
    Repository.prototype._readBranchesOrTags = function (dir) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var names;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, readDirAsync(path.join(this.gitDir, 'refs', dir))];
                    case 1:
                        names = _a.sent();
                        return [4 /*yield*/, Promise.all(names.map(function (name) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _a = {
                                                name: name
                                            };
                                            return [4 /*yield*/, this._readCommitByBranchOrTag(dir, name)];
                                        case 1: return [2 /*return*/, (_a.commit = _b.sent(),
                                                _a)];
                                    }
                                });
                            }); }))];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Repository.prototype._readBranchesOrTagsSync = function (dir) {
        var _this = this;
        var names = fs.readdirSync(path.join(this.gitDir, 'refs', dir));
        return names.map(function (name) {
            return {
                name: name,
                commit: _this._readCommitByBranchOrTagSync(dir, name),
            };
        });
    };
    Repository.prototype._readCommitByBranchOrTag = function (dir, name) {
        return __awaiter(this, void 0, void 0, function () {
            var hash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, readFileAsync(path.join(this.gitDir, 'refs', dir, name), 'utf8')];
                    case 1:
                        hash = (_a.sent()).trim();
                        return [4 /*yield*/, commit_1.Commit.readCommit(this.gitDir, hash)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Repository.prototype._readCommitByBranchOrTagSync = function (dir, name) {
        var hash = fs.readFileSync(path.join(this.gitDir, 'refs', dir, name), 'utf8').trim();
        return commit_1.Commit.readCommitSync(this.gitDir, hash);
    };
    Repository.prototype.readBranches = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._readBranchesOrTags('heads')];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Repository.prototype.readBranchesSync = function () {
        return this._readBranchesOrTagsSync('heads');
    };
    Repository.prototype.readCommitByBranch = function (branchName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._readCommitByBranchOrTag('heads', branchName)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Repository.prototype.readCommitByBranchSync = function (branchName) {
        return this._readCommitByBranchOrTagSync('heads', branchName);
    };
    Repository.prototype.readTags = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._readBranchesOrTags('tags')];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Repository.prototype.readTagsSync = function () {
        return this._readBranchesOrTagsSync('tags');
    };
    Repository.prototype.readCommitByTag = function (tagName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._readCommitByBranchOrTag('tags', tagName)];
            });
        });
    };
    Repository.prototype.readCommitByTagSync = function (tagName) {
        return this._readCommitByBranchOrTagSync('tags', tagName);
    };
    return Repository;
}());
exports.Repository = Repository;
